;-----------------------------------------------------------------------
; DateiName        :  adder.asm
;-----------------------------------------------------------------------
; Autor            :  Christian Rsch
;
; Erstellungsdatum :  15.11.2001
;-----------------------------------------------------------------------
; Info :  Das Programm lsst sich zwei Zahlen eingeben und gibt die
;         Summe aus.
;-----------------------------------------------------------------------


; Dies ist das Daten-Segment

data SEGMENT
assume DS:data
plz_enter db "Bitte 2 Zahlen eingeben! Diese werden addiert."
cr_lf     db 13,10,"$"
result    db "Ergebnis: ","$"
data ends



; Dies ist das Stack-Segment

stackdata SEGMENT stack
assume SS:stackdata
        db 256 dup(?)           ; definiert die Grsse des Stacks
stackdata ends



; Dies ist das Code-Segment

code SEGMENT
ASSUME CS:code

;-----------------------------------------------------------------------
; Funktion        : PrintText
;-----------------------------------------------------------------------
; Info : gibt einen Text aus (via DOS)
;-----------------------------------------------------------------------
; IN  : DX: OFFSET des Strings
; OUT : ---
;-----------------------------------------------------------------------
PrintText PROC                  ; das muss evtl. vertauscht sein (TASM-Eigenheit)
        push  ax                ; ax sichern
        mov   ax,0900h          ; Funktion 0900h (String ausgeben)
        int   21h               ; Interrupt auslsen
        pop   ax                ; ax zurck
        ret
ENDP
;-----------------------------------------------------------------------
; Funktion        : read_number
;-----------------------------------------------------------------------
; Info : liest eine Zahl von der Tastatur und schreibt diese auf den
;        Bildschirm und ins AX
;-----------------------------------------------------------------------
; IN  : ---
; OUT : AX: eingegebene Zahl
;-----------------------------------------------------------------------
read_number PROC
        push    bx              ; bx sichern
        push    cx              ; cx sichern
        xor     cx,cx           ; cx lschen
rn_wait4keys:
        mov     ah,01h          ; Tastaturbuffer checken
        int     16h
        jz      rn_wait4keys    ; warten bis Taste gedrckt
        mov     ah,00h          ; Tastaturbuffer lesen
        int     16h

        cmp     al,13
        je      rn_ende         ; bei ENTER beenden

        cmp     al,'0'          ; kleiner '0' ?
        jb      rn_wait4keys    ; dann zurck
        cmp     al,'9'          ; grsser '9' ?
        ja      rn_wait4keys    ; dann zurck

        mov     ah,0eh          ; Zeichen ausgeben
        xor     bl,0            ; Farbe 0
        int     10h

        mov     bx,cx           ; cx=cx*10
        shl     bx,1
        mov     cx,bx
        shl     bx,2
        add     cx,bx

        xor     ah,ah           ; obere Bits lschen
        sub     al,'0'          ; ASCII 2 Zahl
        add     cx,ax           ; cx=cx+Eingabe

        jmp     rn_wait4keys    ; weiter lesen

rn_ende:
        mov     ax,cx           ; Ergebnis nach ax
        pop     cx              ; cx zurck
        pop     bx              ; bx zurck
        ret
ENDP

;-----------------------------------------------------------------------
; Funktion        : write_number
;-----------------------------------------------------------------------
; Info :  Schreibt die Zahl, die in AX ist, auf den Bildschirm
;-----------------------------------------------------------------------
; IN  : AX: auszugebende Zahl
; OUT : ---
;-----------------------------------------------------------------------
write_number PROC
        push ax                 ; ax sichern
        push bx                 ; bx sichern
        push dx                 ; dx sichern

        mov  dx,-'0'            ; "Endzeichen" der Zahl

        mov  bx,10
wn_goon:
        push dx                 ; Ziffer auf Stack
        xor  dx,dx
        div  bx                 ; durch 10 teilen
        cmp  ax,0
        jnz  wn_goon            ; weiter wenn noch nicht 0

        mov     ax,dx           ; erste Zahl holen
        add     ax,'0'          ; Zahl 2 ASCII
wn_output:
        mov     ah,0eh          ; Zeichen ausgeben
        xor     bl,0            ; Farbe 0
        int     10h

        pop     ax              ; Zahl holen
        add     ax,'0'          ; Zahl 2 ASCII
        jnz     wn_output

        pop     dx              ; dx zurck
        pop     bx              ; bx zurck
        pop     ax              ; ax zurck

        ret
ENDP


start:                          ; hier beginnt die Abarbeitung des Programmshier beginnt die
        mov     ax, data        ; Adresse des Daten Segments nach ax
        mov     ds, ax          ; DatenSegment nach ds

        mov     dx,OFFSET plz_enter
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        call    read_number     ; Zahl holen
        mov     bx,ax           ; Zahl merken

        mov     dx,OFFSET cr_lf
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        call    read_number     ; Zahl holen
        add     ax,bx           ; Zahl addieren

        call    PrintText       ; Funktion zur Textausgabe aufrufen
        mov     dx,OFFSET result
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        call    write_number    ; Zahl schreiben
        mov     dx,OFFSET cr_lf
        call    PrintText       ; Funktion zur Textausgabe aufrufen

        mov     ax, 4c00h       ; Funktion 4c00h (Programmende)
        int     21h             ; Interuppt auslsen


code ENDS



     end     start              ; Start als Einsprungpunkt definieren

;-----
; EOF
;-----
